Index: /palm/trunk/SOURCE/lpm_init.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init.f90	(revision 2231)
+++ /palm/trunk/SOURCE/lpm_init.f90	(revision 2232)
@@ -20,4 +20,5 @@
 ! Current revisions:
 ! -----------------
+! Adjustments according to new topography realization
 ! 
 ! 
@@ -146,5 +147,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  de_dx, de_dy, de_dz, zu, zw, z0
+        ONLY:  de_dx, de_dy, de_dz, zu, zw
 
     USE control_parameters,                                                    &
@@ -157,5 +158,5 @@
     USE indices,                                                               &
         ONLY:  nx, nxl, nxlg, nxrg, nxr, ny, nyn, nys, nyng, nysg, nz, nzb,    &
-               nzb_w_inner, nzt
+               nzb_max, nzt, wall_flags_0
 
     USE kinds
@@ -196,4 +197,7 @@
         ONLY:  random_function
 
+    USE surface_mod,                                                           &
+        ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
     IMPLICIT NONE
 
@@ -287,4 +291,14 @@
        number_of_particle_groups = max_number_of_particle_groups
     ENDIF
+!
+!-- Check if downward-facing walls exist. This case, reflection boundary
+!-- conditions (as well as subgrid-scale velocities) may do not work
+!-- propably (not realized so far). 
+    IF ( surf_def_h(1)%ns >= 1 )  THEN
+       WRITE( message_string, * ) 'Overhanging topograpyh do not work '// &   
+                                  'with particles' 
+       CALL message( 'lpm_init', 'PA0212', 0, 1, 0, 6, 0 )
+
+    ENDIF 
 
 !
@@ -355,5 +369,5 @@
        
        ALLOCATE ( log_z_z0(0:number_of_sublayers) ) 
-       z_p         = zu(nzb+1) - zw(nzb)
+       z_p = zu(nzb+1) - zw(nzb)
 
 !
@@ -362,5 +376,6 @@
 !--    However, sensitivity studies showed that the effect is 
 !--    negligible. 
-       z0_av_local  = SUM( z0(nys:nyn,nxl:nxr) )
+       z0_av_local  = SUM( surf_def_h(0)%z0 ) + SUM( surf_lsm_h%z0 ) +         &
+                      SUM( surf_usm_h%z0 )
        z0_av_global = 0.0_wp
 
@@ -577,4 +592,6 @@
     INTEGER(iwp)               ::  j           !< loop variable ( particles per point )
     INTEGER(iwp)               ::  jp          !< index variable along y
+    INTEGER(iwp)               ::  k           !< index variable along z
+    INTEGER(iwp)               ::  k_surf      !< index of surface grid point
     INTEGER(iwp)               ::  kp          !< index variable along z
     INTEGER(iwp)               ::  loop_stride !< loop variable for initialization
@@ -679,20 +696,38 @@
 !
 !--                            Determine the grid indices of the particle position
-                              ip = ( tmp_particle%x + 0.5_wp * dx ) * ddx
+                               ip = ( tmp_particle%x + 0.5_wp * dx ) * ddx
                                jp = ( tmp_particle%y + 0.5_wp * dy ) * ddy
                                kp = tmp_particle%z / dz + 1 + offset_ocean_nzt
+!
+!--                            Determine surface level. Therefore, check for
+!--                            upward-facing wall on w-grid. MAXLOC will return 
+!--                            the index of the lowest upward-facing wall.
+                               k_surf = MAXLOC(                                &
+                                             MERGE( 1, 0,                      &
+                                   BTEST( wall_flags_0(nzb:nzb_max,jp,ip), 18 )&
+                                                  ), DIM = 1                   &
+                                              ) - 1
 
                                IF ( seed_follows_topography )  THEN
 !
 !--                               Particle height is given relative to topography
-                                  kp = kp + nzb_w_inner(jp,ip)
-                                  tmp_particle%z = tmp_particle%z +            &
-                                                         zw(nzb_w_inner(jp,ip))
-                                  IF ( kp > nzt )  THEN
+                                  kp = kp + k_surf
+                                  tmp_particle%z = tmp_particle%z + zw(k_surf)
+!--                               Skip particle release if particle position is
+!--                               above model top, or within topography in case
+!--                               of overhanging structures.
+                                  IF ( kp > nzt  .OR.                          &
+                                 .NOT. BTEST( wall_flags_0(kp,jp,ip), 0 ) )  THEN
                                      pos_x = pos_x + pdx(i)
                                      CYCLE xloop
                                   ENDIF
+!
+!--                            Skip particle release if particle position is 
+!--                            below surface, or within topography in case
+!--                            of overhanging structures.
                                ELSEIF ( .NOT. seed_follows_topography .AND.    &
-                                        tmp_particle%z <= zw(nzb_w_inner(jp,ip)) )  THEN
+                                         tmp_particle%z <= zw(k_surf)  .OR.    &
+                                        .NOT. BTEST( wall_flags_0(kp,jp,ip), 0 ) )&
+                               THEN
                                   pos_x = pos_x + pdx(i)
                                   CYCLE xloop                               
@@ -820,5 +855,5 @@
                                      pdx(particles(n)%group)
                       particles(n)%x = particles(n)%x +                        &
-                              MERGE( rand_contr, SIGN( dx, rand_contr ), &
+                              MERGE( rand_contr, SIGN( dx, rand_contr ),       &
                                      ABS( rand_contr ) < dx                    &
                                    ) 
@@ -828,5 +863,5 @@
                                      pdy(particles(n)%group)
                       particles(n)%y = particles(n)%y +                        &
-                              MERGE( rand_contr, SIGN( dy, rand_contr ), &
+                              MERGE( rand_contr, SIGN( dy, rand_contr ),       &
                                      ABS( rand_contr ) < dy                    &
                                    ) 
@@ -836,5 +871,5 @@
                                      pdz(particles(n)%group)
                       particles(n)%z = particles(n)%z +                        &
-                              MERGE( rand_contr, SIGN( dz, rand_contr ), &
+                              MERGE( rand_contr, SIGN( dz, rand_contr ),       &
                                      ABS( rand_contr ) < dz                    &
                                    ) 
@@ -854,8 +889,12 @@
                    i = ( particles(n)%x + 0.5_wp * dx ) * ddx
                    j = ( particles(n)%y + 0.5_wp * dy ) * ddy
-                   IF ( particles(n)%z <= zw(nzb_w_inner(j,i)) )  THEN
+                   k =   particles(n)%z / dz + 1 + offset_ocean_nzt
+!
+!--                Check if particle is within topography
+                   IF ( .NOT. BTEST( wall_flags_0(k,j,i), 0 ) )  THEN
                       particles(n)%particle_mask = .FALSE.
                       deleted_particles = deleted_particles + 1
                    ENDIF
+
                 ENDDO
              ENDDO
Index: /palm/trunk/SOURCE/lpm_init_sgs_tke.f90
===================================================================
--- /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 2231)
+++ /palm/trunk/SOURCE/lpm_init_sgs_tke.f90	(revision 2232)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adjustments according to new topography realization
 ! 
 ! Former revisions:
@@ -73,6 +73,6 @@
 
     USE indices,                                                               &
-        ONLY:  nbgp, ngp_2dh_outer, nxl, nxr, nyn, nys, nzb, nzb_s_inner,      &
-               nzb_s_outer, nzt
+        ONLY:  nbgp, ngp_2dh_outer, nxl, nxr, nyn, nys, nzb,                   &
+               nzb_s_outer, nzt, wall_flags_0
 
     USE kinds
@@ -86,10 +86,15 @@
         ONLY:  flow_statistics_called, hom, sums, sums_l
 
+    USE surface_mod,                                                           &
+        ONLY:  bc_h
+
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i      !<
-    INTEGER(iwp) ::  j      !<
-    INTEGER(iwp) ::  k      !<
-
+    INTEGER(iwp) ::  i      !< index variable along x
+    INTEGER(iwp) ::  j      !< index variable along y
+    INTEGER(iwp) ::  k      !< index variable along z
+    INTEGER(iwp) ::  m      !< running index for the surface elements 
+
+    REAL(wp) ::  flag1      !< flag to mask topography
 
 !
@@ -99,18 +104,22 @@
           DO  k = nzb, nzt+1
 
-             IF ( k <= nzb_s_inner(j,i-1)  .AND.  k > nzb_s_inner(j,i)  .AND.  &
-                  k  > nzb_s_inner(j,i+1) )                                    &
+             IF ( .NOT. BTEST( wall_flags_0(k,j,i-1), 0 )  .AND.               &
+                        BTEST( wall_flags_0(k,j,i), 0   )  .AND.               &
+                        BTEST( wall_flags_0(k,j,i+1), 0 ) )                    &
              THEN
                 de_dx(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j,i+1) - e(k,j,i) ) * ddx
-             ELSEIF ( k  > nzb_s_inner(j,i-1)  .AND.  k > nzb_s_inner(j,i)     &
-                      .AND.  k <= nzb_s_inner(j,i+1) )                         &
+             ELSEIF ( BTEST( wall_flags_0(k,j,i-1), 0 )  .AND.                 &
+                      BTEST( wall_flags_0(k,j,i), 0   )  .AND.                 &
+                .NOT. BTEST( wall_flags_0(k,j,i+1), 0 ) )                      &
              THEN
                 de_dx(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j,i) - e(k,j,i-1) ) * ddx
-             ELSEIF ( k < nzb_s_inner(j,i)  .AND.  k < nzb_s_inner(j,i+1) )    &
+             ELSEIF ( .NOT. BTEST( wall_flags_0(k,j,i), 22   )  .AND.          &
+                      .NOT. BTEST( wall_flags_0(k,j,i+1), 22 ) )               &   
              THEN
                 de_dx(k,j,i) = 0.0_wp
-             ELSEIF ( k < nzb_s_inner(j,i-1)  .AND.  k < nzb_s_inner(j,i) )    &
+             ELSEIF ( .NOT. BTEST( wall_flags_0(k,j,i-1), 22 )  .AND.          &
+                      .NOT. BTEST( wall_flags_0(k,j,i), 22   ) )               &
              THEN
                 de_dx(k,j,i) = 0.0_wp
@@ -119,18 +128,22 @@
              ENDIF
 
-             IF ( k <= nzb_s_inner(j-1,i)  .AND.  k > nzb_s_inner(j,i)  .AND.  &
-                  k  > nzb_s_inner(j+1,i) )                                    &
+             IF ( .NOT. BTEST( wall_flags_0(k,j-1,i), 0 )  .AND.               &
+                        BTEST( wall_flags_0(k,j,i), 0   )  .AND.               &
+                        BTEST( wall_flags_0(k,j+1,i), 0 ) )                    &
              THEN
                 de_dy(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j+1,i) - e(k,j,i) ) * ddy
-             ELSEIF ( k  > nzb_s_inner(j-1,i)  .AND.  k  > nzb_s_inner(j,i)    &
-                      .AND.  k <= nzb_s_inner(j+1,i) )                         &
+             ELSEIF ( BTEST( wall_flags_0(k,j-1,i), 0 )  .AND.                 &
+                      BTEST( wall_flags_0(k,j,i), 0   )  .AND.                 &
+                .NOT. BTEST( wall_flags_0(k,j+1,i), 0 ) )                      &
              THEN
                 de_dy(k,j,i) = 2.0_wp * sgs_wf_part *                          &
                                ( e(k,j,i) - e(k,j-1,i) ) * ddy
-             ELSEIF ( k < nzb_s_inner(j,i)  .AND.  k < nzb_s_inner(j+1,i) )    &
+             ELSEIF ( .NOT. BTEST( wall_flags_0(k,j,i), 22   )  .AND.          &
+                      .NOT. BTEST( wall_flags_0(k,j+1,i), 22 ) )               &   
              THEN
                 de_dy(k,j,i) = 0.0_wp
-             ELSEIF ( k < nzb_s_inner(j-1,i)  .AND.  k < nzb_s_inner(j,i) )    &
+             ELSEIF ( .NOT. BTEST( wall_flags_0(k,j-1,i), 22 )  .AND.          &
+                      .NOT. BTEST( wall_flags_0(k,j,i), 22   ) )               &
              THEN
                 de_dy(k,j,i) = 0.0_wp
@@ -144,25 +157,38 @@
 
 !
-!-- TKE gradient along z, including bottom and top boundary conditions
+!-- TKE gradient along z at topograhy and  including bottom and top boundary conditions
     DO  i = nxl, nxr
        DO  j = nys, nyn
-
-          DO  k = nzb_s_inner(j,i)+2, nzt-1
-             de_dz(k,j,i)  = 2.0_wp * sgs_wf_part *                            &
-                             ( e(k+1,j,i) - e(k-1,j,i) ) / ( zu(k+1)-zu(k-1) )
-          ENDDO
-
-          k = nzb_s_inner(j,i)
-          de_dz(nzb:k,j,i) = 0.0_wp
-          de_dz(k+1,j,i)   = 2.0_wp * sgs_wf_part *                            &
-                             ( e(k+2,j,i) - e(k+1,j,i) ) / ( zu(k+2) - zu(k+1) )
+          DO  k = nzb+1, nzt-1
+!
+!--          Flag to mask topography
+             flag1 = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 0  ) )
+
+             de_dz(k,j,i) = 2.0_wp * sgs_wf_part *                             &
+                           ( e(k+1,j,i) - e(k-1,j,i) ) / ( zu(k+1) - zu(k-1) ) &
+                                                 * flag1 
+          ENDDO
+!
+!--       upward-facing surfaces
+          DO  m = bc_h(0)%start_index(j,i), bc_h(0)%end_index(j,i)
+             k            = bc_h(0)%k(m)
+             de_dz(k,j,i) = 2.0_wp * sgs_wf_part *                             &
+                           ( e(k+1,j,i) - e(k,j,i)   ) / ( zu(k+1) - zu(k) )
+          ENDDO
+!
+!--       downward-facing surfaces
+          DO  m = bc_h(1)%start_index(j,i), bc_h(1)%end_index(j,i)
+             k            = bc_h(1)%k(m)
+             de_dz(k,j,i) = 2.0_wp * sgs_wf_part *                             &
+                           ( e(k,j,i) - e(k-1,j,i)   ) / ( zu(k) - zu(k-1) )
+          ENDDO
+
+          de_dz(nzb,j,i)   = 0.0_wp
           de_dz(nzt,j,i)   = 0.0_wp
           de_dz(nzt+1,j,i) = 0.0_wp
        ENDDO
     ENDDO
-
-
-!
-!-- Lateral boundary conditions
+!
+!-- Ghost point exchange
     CALL exchange_horiz( de_dx, nbgp )
     CALL exchange_horiz( de_dy, nbgp )
@@ -185,7 +211,11 @@
        DO  i = nxl, nxr
           DO  j =  nys, nyn
-             DO  k = nzb_s_outer(j,i), nzt+1
-                sums_l(k,1,0)  = sums_l(k,1,0)  + u(k,j,i)
-                sums_l(k,2,0)  = sums_l(k,2,0)  + v(k,j,i)
+             DO  k = nzb, nzt+1
+!
+!--             Flag indicate nzb_s_outer 
+                flag1 = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 24 ) )
+
+                sums_l(k,1,0)  = sums_l(k,1,0)  + u(k,j,i) * flag1
+                sums_l(k,2,0)  = sums_l(k,2,0)  + v(k,j,i) * flag1
              ENDDO
           ENDDO
@@ -221,9 +251,13 @@
        DO  i = nxl, nxr
           DO  j = nys, nyn
-             DO  k = nzb_s_outer(j,i), nzt+1
-                sums_l(k,8,0)  = sums_l(k,8,0)  + e(k,j,i)
-                sums_l(k,30,0) = sums_l(k,30,0) + ( u(k,j,i) - hom(k,1,1,0) )**2
-                sums_l(k,31,0) = sums_l(k,31,0) + ( v(k,j,i) - hom(k,1,2,0) )**2
-                sums_l(k,32,0) = sums_l(k,32,0) + w(k,j,i)**2
+             DO  k = nzb, nzt+1
+!
+!--             Flag indicate nzb_s_outer 
+                flag1 = MERGE( 1.0_wp, 0.0_wp, BTEST( wall_flags_0(k,j,i), 24 ) )
+
+                sums_l(k,8,0)  = sums_l(k,8,0)  + e(k,j,i)                       * flag1
+                sums_l(k,30,0) = sums_l(k,30,0) + ( u(k,j,i) - hom(k,1,1,0) )**2 * flag1
+                sums_l(k,31,0) = sums_l(k,31,0) + ( v(k,j,i) - hom(k,1,2,0) )**2 * flag1
+                sums_l(k,32,0) = sums_l(k,32,0) + w(k,j,i)**2                    * flag1
              ENDDO
           ENDDO
Index: /palm/trunk/SOURCE/ls_forcing_mod.f90
===================================================================
--- /palm/trunk/SOURCE/ls_forcing_mod.f90	(revision 2231)
+++ /palm/trunk/SOURCE/ls_forcing_mod.f90	(revision 2232)
@@ -20,5 +20,8 @@
 ! Current revisions:
 ! ------------------
-! 
+! Adopt to new topography structure, even though no well-conceived topography 
+! concept concerning nudging and large-scale for exist so far. 
+!
+! Also adopt to new surface-structure, i.e. fluxes are obtained from data-types 
 ! 
 ! Former revisions:
@@ -356,5 +359,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  p_surf, pt_surf, q_surf, qsws, qsws_surf, shf, shf_surf,     &
+           ONLY:  p_surf, pt_surf, q_surf, qsws_surf, shf_surf,                &
                   heatflux_input_conversion, waterflux_input_conversion,       &
                   time_surf, time_vert, ug, ug_vert, vg, vg_vert
@@ -369,8 +372,12 @@
        USE kinds
 
+       USE surface_mod,                                                        &
+           ONLY:  surf_def_h, surf_lsm_h, surf_usm_h
+
        IMPLICIT NONE
 
        INTEGER(iwp) ::  nt                     !<
 
+       REAL(wp)             :: dum_surf_flux  !<
        REAL(wp)             :: fac            !<
        REAL(wp), INTENT(in) :: time           !<
@@ -398,7 +405,15 @@
 !--       In case of Neumann boundary condition pt_surface is needed for 
 !--       calculation of reference density
-          shf        = ( shf_surf(nt) + fac * ( shf_surf(nt+1) - shf_surf(nt) )&
-                       ) * heatflux_input_conversion(nzb)
-          pt_surface = pt_surf(nt) + fac * ( pt_surf(nt+1) - pt_surf(nt) )
+          dum_surf_flux = ( shf_surf(nt) + fac *                               &
+                            ( shf_surf(nt+1) - shf_surf(nt) )                  &
+                          ) * heatflux_input_conversion(nzb)
+!
+!--       Save surface sensible heat flux on default, natural and urban surface
+!--       type, if required 
+          IF ( surf_def_h(0)%ns >= 1 )  surf_def_h(0)%shf(:) = dum_surf_flux
+          IF ( surf_lsm_h%ns    >= 1 )  surf_lsm_h%shf(:)    = dum_surf_flux
+          IF ( surf_usm_h%ns    >= 1 )  surf_usm_h%shf(:)    = dum_surf_flux
+
+          pt_surface    = pt_surf(nt) + fac * ( pt_surf(nt+1) - pt_surf(nt) )
 
        ENDIF
@@ -411,7 +426,13 @@
 
        ELSEIF ( ibc_q_b == 1 )  THEN
-
-          qsws = ( qsws_surf(nt) + fac * ( qsws_surf(nt+1) - qsws_surf(nt) )   &
-                 ) * waterflux_input_conversion(nzb)
+          dum_surf_flux = ( qsws_surf(nt) + fac *                              &
+                             ( qsws_surf(nt+1) - qsws_surf(nt) )               &
+                             ) * waterflux_input_conversion(nzb)
+!
+!--       Save surface sensible heat flux on default, natural and urban surface
+!--       type, if required 
+          IF ( surf_def_h(0)%ns >= 1 )  surf_def_h(0)%qsws(:) = dum_surf_flux
+          IF ( surf_lsm_h%ns    >= 1 )  surf_lsm_h%qsws(:)    = dum_surf_flux
+          IF ( surf_usm_h%ns    >= 1 )  surf_usm_h%qsws(:)    = dum_surf_flux
 
        ENDIF
@@ -516,7 +537,9 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_u_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tend(k,j,i) = tend(k,j,i) + td_lsa_lpt(k,nt) + fac *     &
-                                    ( td_lsa_lpt(k,nt+1) - td_lsa_lpt(k,nt) )
+                                    ( td_lsa_lpt(k,nt+1) - td_lsa_lpt(k,nt) ) *&
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                    ENDDO
                 ENDDO
@@ -527,7 +550,9 @@
              DO  i = nxl, nxr
                 DO  j = nys, nyn
-                   DO  k = nzb_u_inner(j,i)+1, nzt
+                   DO  k = nzb+1, nzt
                       tend(k,j,i) = tend(k,j,i) + td_lsa_q(k,nt) + fac *       &
-                                    ( td_lsa_q(k,nt+1) - td_lsa_q(k,nt) )
+                                    ( td_lsa_q(k,nt+1) - td_lsa_q(k,nt) ) *    &
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                    ENDDO
                 ENDDO
@@ -546,7 +571,9 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb_u_inner(j,i)+1, nzt
+                      DO  k = nzb+1, nzt
                          tend(k,j,i) = tend(k,j,i) + td_sub_lpt(k,nt) + fac *  &
-                                       ( td_sub_lpt(k,nt+1) - td_sub_lpt(k,nt) )
+                                     ( td_sub_lpt(k,nt+1) - td_sub_lpt(k,nt) )*&
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                       ENDDO
                    ENDDO
@@ -557,7 +584,9 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      DO  k = nzb_u_inner(j,i)+1, nzt
+                      DO  k = nzb+1, nzt
                          tend(k,j,i) = tend(k,j,i) + td_sub_q(k,nt) + fac *    &
-                                       ( td_sub_q(k,nt+1) - td_sub_q(k,nt) )
+                                       ( td_sub_q(k,nt+1) - td_sub_q(k,nt) ) * &
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                       ENDDO
                    ENDDO
@@ -618,14 +647,18 @@
           CASE ( 'pt' )
 
-             DO  k = nzb_u_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
                 tend(k,j,i) = tend(k,j,i) + td_lsa_lpt(k,nt)                   &
-                              + fac * ( td_lsa_lpt(k,nt+1) - td_lsa_lpt(k,nt) )
+                             + fac * ( td_lsa_lpt(k,nt+1) - td_lsa_lpt(k,nt) )*&
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
              ENDDO
 
           CASE ( 'q' )
 
-             DO  k = nzb_u_inner(j,i)+1, nzt
+             DO  k = nzb+1, nzt
                 tend(k,j,i) = tend(k,j,i) + td_lsa_q(k,nt)                     &
-                              + fac * ( td_lsa_q(k,nt+1) - td_lsa_q(k,nt) )
+                              + fac * ( td_lsa_q(k,nt+1) - td_lsa_q(k,nt) ) *  &
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
              ENDDO
 
@@ -640,14 +673,18 @@
              CASE ( 'pt' )
 
-                DO  k = nzb_u_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
                    tend(k,j,i) = tend(k,j,i) + td_sub_lpt(k,nt) + fac *        &
-                                 ( td_sub_lpt(k,nt+1) - td_sub_lpt(k,nt) )
+                                 ( td_sub_lpt(k,nt+1) - td_sub_lpt(k,nt) ) *   &
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDDO
   
              CASE ( 'q' )
 
-                DO  k = nzb_u_inner(j,i)+1, nzt
+                DO  k = nzb+1, nzt
                    tend(k,j,i) = tend(k,j,i) + td_sub_q(k,nt) + fac *          &
-                                 ( td_sub_q(k,nt+1) - td_sub_q(k,nt) )
+                                 ( td_sub_q(k,nt+1) - td_sub_q(k,nt) ) *       &
+                                        MERGE( 1.0_wp, 0.0_wp,                 &
+                                               BTEST( wall_flags_0(k,j,i), 0 ) )
                 ENDDO
 
